<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: scan_image_boxes_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_6fa195adb58ca7edc2dded7e6bc48796.html">image_processing</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">scan_image_boxes_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2013  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_SCAN_IMAGE_bOXES_ABSTRACT_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_SCAN_IMAGE_bOXES_ABSTRACT_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../geometry.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;../image_processing.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#include &quot;../array2d.h&quot;</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &quot;full_object_detection_abstract.h&quot;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &quot;../image_transforms/segment_image_abstract.h&quot;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160; </div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;{</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160; </div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160; </div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="keyword">class </span>default_box_generator</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    {</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160; </div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">typename</span> image_type&gt;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;        <span class="keywordtype">void</span> operator() (</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;            <span class="keyword">const</span> image_type&amp; img,</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;            std::vector&lt;rectangle&gt;&amp; rects</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;        ) <span class="keyword">const</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        {</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;            rects.clear();</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;            find_candidate_object_locations(img, rects);</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        }</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    };</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160; </div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> serialize  (<span class="keyword">const</span> default_box_generator&amp;, std::ostream&amp; ) {}</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    <span class="keyword">inline</span> <span class="keywordtype">void</span> deserialize(      default_box_generator&amp;, std::istream&amp; ) {}</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160; </div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;        <span class="keyword">typename</span> Feature_extractor_type,</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keyword">typename</span> Box_generator = default_box_generator</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        &gt;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    <span class="keyword">class </span>scan_image_boxes : noncopyable</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    {</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160; </div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        <span class="keyword">typedef</span> matrix&lt;double,0,1&gt; feature_vector_type;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160; </div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        <span class="keyword">typedef</span> Feature_extractor_type feature_extractor_type;</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="keyword">typedef</span> Box_generator box_generator;</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160; </div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;        scan_image_boxes (</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;        );  </div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;            <span class="keyword">typename</span> image_type</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            &gt;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        <span class="keywordtype">void</span> load (</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;            <span class="keyword">const</span> image_type&amp; img</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        );</div><div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;        <span class="keywordtype">bool</span> is_loaded_with_image (</div><div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        <span class="keyword">const</span> feature_extractor_type&amp; get_feature_extractor (</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        <span class="keywordtype">void</span> copy_configuration(</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;            <span class="keyword">const</span> feature_extractor_type&amp; fe</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        );</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="keywordtype">void</span> copy_configuration(</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;            <span class="keyword">const</span> box_generator&amp; bg</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        );</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;        <span class="keyword">const</span> box_generator&amp; get_box_generator (</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        <span class="keywordtype">void</span> copy_configuration (</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;            <span class="keyword">const</span> scan_image_boxes&amp; item</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        );</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        <span class="keywordtype">long</span> get_num_dimensions (</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_num_spatial_pyramid_levels (</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        <span class="keywordtype">void</span> set_num_spatial_pyramid_levels (</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;            <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> levels</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        );</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        <span class="keywordtype">void</span> detect (</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;            <span class="keyword">const</span> feature_vector_type&amp; w,</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;            std::vector&lt;std::pair&lt;double, rectangle&gt; &gt;&amp; dets,</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;            <span class="keyword">const</span> <span class="keywordtype">double</span> thresh</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;        <span class="keywordtype">void</span> get_feature_vector (</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;            <span class="keyword">const</span> full_object_detection&amp; obj,</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;            feature_vector_type&amp; psi</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        full_object_detection get_full_object_detection (</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;            <span class="keyword">const</span> rectangle&amp; rect,</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;            <span class="keyword">const</span> feature_vector_type&amp; w</div><div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;        <span class="keyword">const</span> rectangle get_best_matching_rect (</div><div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;            <span class="keyword">const</span> rectangle&amp; rect</div><div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classdlib_1_1scan__image__boxes.html#af6bc56d8fa3c810851769bf9a69d24f6">get_num_detection_templates</a> (</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> get_num_movable_components_per_detection_template (</div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;        )<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }</div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;    };</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160; </div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160; </div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;        <span class="keyword">typename</span> Feature_extractor_type,</div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;        <span class="keyword">typename</span> Box_generator </div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;        &gt;</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;    <span class="keywordtype">void</span> serialize (</div><div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;        <span class="keyword">const</span> scan_image_boxes&lt;Feature_extractor_type,Box_generator&gt;&amp; item,</div><div class="line"><a name="l00371"></a><span class="lineno">  371</span>&#160;        std::ostream&amp; out</div><div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;    );</div><div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;        <span class="keyword">typename</span> Feature_extractor_type,</div><div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;        <span class="keyword">typename</span> Box_generator </div><div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;        &gt;</div><div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;    <span class="keywordtype">void</span> deserialize (</div><div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;        scan_image_boxes&lt;Feature_extractor_type,Box_generator&gt;&amp; item,</div><div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;        std::istream&amp; in </div><div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;    );</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160; </div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;}</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160; </div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;<span class="preprocessor">#endif // DLIB_SCAN_IMAGE_bOXES_ABSTRACT_Hh_</span></div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="aclassdlib_1_1scan__image__boxes_html_af6bc56d8fa3c810851769bf9a69d24f6"><div class="ttname"><a href="classdlib_1_1scan__image__boxes.html#af6bc56d8fa3c810851769bf9a69d24f6">dlib::scan_image_boxes::get_num_detection_templates</a></div><div class="ttdeci">unsigned long get_num_detection_templates() const</div><div class="ttdef"><b>Definition:</b> scan_image_boxes.h:117</div></div>
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
